// This file is @generated by prost-build.
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct SoftwareInfo {
    #[prost(int32, tag = "2")]
    pub unknown2: i32,
    #[prost(message, optional, tag = "4")]
    pub firmware: ::core::option::Option<FirmwareInfo>,
    #[prost(fixed64, tag = "5")]
    pub unknown5: u64,
    #[prost(bool, tag = "6")]
    pub unknown6: bool,
}
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct FirmwareInfo {
    /// Note: order might not be correct
    #[prost(message, optional, tag = "1")]
    pub case: ::core::option::Option<FirmwareVersion>,
    #[prost(message, optional, tag = "2")]
    pub right: ::core::option::Option<FirmwareVersion>,
    #[prost(message, optional, tag = "3")]
    pub left: ::core::option::Option<FirmwareVersion>,
}
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct FirmwareVersion {
    #[prost(string, tag = "1")]
    pub unknown: ::prost::alloc::string::String,
    #[prost(string, tag = "2")]
    pub version_string: ::prost::alloc::string::String,
}
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct HardwareInfo {
    #[prost(int32, tag = "1")]
    pub unknown1: i32,
    #[prost(int32, tag = "2")]
    pub unknown2: i32,
    #[prost(int32, tag = "5")]
    pub unknown5: i32,
    #[prost(int32, tag = "6")]
    pub unknown6: i32,
    #[prost(message, optional, tag = "7")]
    pub serial_number: ::core::option::Option<SerialNumbers>,
}
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct SerialNumbers {
    #[prost(string, tag = "1")]
    pub case: ::prost::alloc::string::String,
    #[prost(string, tag = "2")]
    pub right: ::prost::alloc::string::String,
    #[prost(string, tag = "3")]
    pub left: ::prost::alloc::string::String,
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct RuntimeInfo {
    /// maybe unix time in ms (consistent ~60s difference to actual time)
    #[prost(int64, tag = "2")]
    pub timestamp_ms: i64,
    #[prost(int32, tag = "3")]
    pub unknown3: i32,
    #[prost(message, optional, tag = "6")]
    pub battery_info: ::core::option::Option<BatteryInfo>,
    #[prost(message, optional, tag = "7")]
    pub placement: ::core::option::Option<PlacementInfo>,
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct BatteryInfo {
    #[prost(message, optional, tag = "1")]
    pub case: ::core::option::Option<DeviceBatteryInfo>,
    #[prost(message, optional, tag = "2")]
    pub left: ::core::option::Option<DeviceBatteryInfo>,
    #[prost(message, optional, tag = "3")]
    pub right: ::core::option::Option<DeviceBatteryInfo>,
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct DeviceBatteryInfo {
    /// battery level in percent
    #[prost(int32, tag = "1")]
    pub level: i32,
    #[prost(enumeration = "BatteryState", tag = "2")]
    pub state: i32,
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct PlacementInfo {
    #[prost(bool, tag = "1")]
    pub right_bud_in_case: bool,
    #[prost(bool, tag = "2")]
    pub left_bud_in_case: bool,
}
/// TODO
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct WallClockMsg {}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct ReadSettingMsg {
    #[prost(oneof = "read_setting_msg::ValueOneof", tags = "4")]
    pub value_oneof: ::core::option::Option<read_setting_msg::ValueOneof>,
}
/// Nested message and enum types in `ReadSettingMsg`.
pub mod read_setting_msg {
    #[derive(Clone, Copy, PartialEq, ::prost::Oneof)]
    pub enum ValueOneof {
        #[prost(enumeration = "super::AllegroSettingType", tag = "4")]
        SettingsId(i32),
    }
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct WriteSettingMsg {
    #[prost(oneof = "write_setting_msg::ValueOneof", tags = "4")]
    pub value_oneof: ::core::option::Option<write_setting_msg::ValueOneof>,
}
/// Nested message and enum types in `WriteSettingMsg`.
pub mod write_setting_msg {
    #[derive(Clone, Copy, PartialEq, ::prost::Oneof)]
    pub enum ValueOneof {
        #[prost(message, tag = "4")]
        Setting(super::SettingValue),
    }
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct SettingsRsp {
    #[prost(oneof = "settings_rsp::ValueOneof", tags = "4")]
    pub value_oneof: ::core::option::Option<settings_rsp::ValueOneof>,
}
/// Nested message and enum types in `SettingsRsp`.
pub mod settings_rsp {
    #[derive(Clone, Copy, PartialEq, ::prost::Oneof)]
    pub enum ValueOneof {
        #[prost(message, tag = "4")]
        Value(super::SettingValue),
    }
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct SettingValue {
    #[prost(
        oneof = "setting_value::ValueOneof",
        tags = "1, 2, 3, 4, 5, 6, 7, 11, 12, 13, 14, 15, 16, 17, 19, 21, 22"
    )]
    pub value_oneof: ::core::option::Option<setting_value::ValueOneof>,
}
/// Nested message and enum types in `SettingValue`.
pub mod setting_value {
    #[derive(Clone, Copy, PartialEq, ::prost::Oneof)]
    pub enum ValueOneof {
        #[prost(bool, tag = "1")]
        AutoOtaEnable(bool),
        /// on-head detection
        #[prost(bool, tag = "2")]
        OhdEnable(bool),
        /// out-of-box experience?
        #[prost(bool, tag = "3")]
        OobeIsFinished(bool),
        #[prost(bool, tag = "4")]
        GestureEnable(bool),
        #[prost(bool, tag = "5")]
        DiagnosticsEnable(bool),
        #[prost(bool, tag = "6")]
        OobeMode(bool),
        #[prost(message, tag = "7")]
        GestureControl(super::GestureControl),
        /// reading anc_accessibility_mode returns non-zero status (code: 2)
        /// reading ancr_state_one_bud returns non-zero status (code: 2)
        /// reading ancr_state_two_buds returns non-zero status (code: 2)
        #[prost(bool, tag = "11")]
        MultipointEnable(bool),
        #[prost(message, tag = "12")]
        AncrGestureLoop(super::AncrGestureLoop),
        #[prost(enumeration = "super::AncState", tag = "13")]
        CurrentAncrState(i32),
        /// might be bool
        #[prost(int32, tag = "14")]
        OttsMode(i32),
        #[prost(bool, tag = "15")]
        VolumeEqEnable(bool),
        #[prost(message, tag = "16")]
        CurrentUserEq(super::EqBands),
        /// value goes from 0 t0 200 (incl.), even/odd indicates left/right
        #[prost(int32, tag = "17")]
        VolumeAsymmetry(i32),
        /// reading last_saved_user_eq returns non-zero status (code: 2)
        #[prost(bool, tag = "19")]
        SumToMono(bool),
        /// id 20 does not seem to exist (yet?)
        #[prost(bool, tag = "21")]
        VolumeExposureNotifications(bool),
        #[prost(bool, tag = "22")]
        SpeechDetection(bool),
    }
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct GestureControl {
    #[prost(message, optional, tag = "1")]
    pub left: ::core::option::Option<DeviceGestureControl>,
    #[prost(message, optional, tag = "2")]
    pub right: ::core::option::Option<DeviceGestureControl>,
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct DeviceGestureControl {
    #[prost(oneof = "device_gesture_control::ValueOneof", tags = "4")]
    pub value_oneof: ::core::option::Option<device_gesture_control::ValueOneof>,
}
/// Nested message and enum types in `DeviceGestureControl`.
pub mod device_gesture_control {
    #[derive(Clone, Copy, PartialEq, ::prost::Oneof)]
    pub enum ValueOneof {
        #[prost(message, tag = "4")]
        Type(super::GestureControlType),
    }
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct GestureControlType {
    #[prost(enumeration = "RegularActionTarget", tag = "1")]
    pub value: i32,
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct AncrGestureLoop {
    #[prost(bool, tag = "1")]
    pub active: bool,
    #[prost(bool, tag = "2")]
    pub off: bool,
    #[prost(bool, tag = "3")]
    pub aware: bool,
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct EqBands {
    /// bands go from -6.0 to 6.0
    #[prost(float, tag = "1")]
    pub low_bass: f32,
    #[prost(float, tag = "2")]
    pub bass: f32,
    #[prost(float, tag = "3")]
    pub mid: f32,
    #[prost(float, tag = "4")]
    pub treble: f32,
    #[prost(float, tag = "5")]
    pub upper_treble: f32,
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct OobeActionRsp {
    #[prost(enumeration = "OobeAction", tag = "1")]
    pub action: i32,
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct QuietModeStatusEvent {
    #[prost(int32, tag = "1")]
    pub source: i32,
}
/// TODO
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct ForceMultipointSwitchMsg {}
/// TODO
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct StartEartipFitTestMsg {}
/// TODO
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct EndEartipFitTestMsg {}
/// TODO
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct SubscribeToEartipFitTestResultsMsg {}
/// TODO
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct EartipFitTestResult {}
/// TODO
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct SetJitterBufferSizePreferenceMsg {}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct DosimeterSummaryEntry {
    #[prost(int32, tag = "1")]
    pub unknown1: i32,
    #[prost(float, tag = "6")]
    pub unknown6: f32,
}
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct DosimeterSummary {
    #[prost(int32, tag = "1")]
    pub unknown1: i32,
    #[prost(message, repeated, tag = "2")]
    pub unknown2: ::prost::alloc::vec::Vec<DosimeterSummaryEntry>,
    #[prost(int32, tag = "4")]
    pub unknown4: i32,
    #[prost(float, tag = "5")]
    pub unknown5: f32,
}
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct DosimeterLiveDbMsg {
    /// convert to dB via log10(x) * 10
    #[prost(float, tag = "2")]
    pub intensity: f32,
}
#[derive(Clone, Copy, Debug, PartialEq, Eq, Hash, PartialOrd, Ord, ::prost::Enumeration)]
#[repr(i32)]
pub enum BatteryState {
    Unknown = 0,
    BatteryNotCharging = 1,
    BatteryCharging = 2,
}
impl BatteryState {
    /// String value of the enum field names used in the ProtoBuf definition.
    ///
    /// The values are not transformed in any way and thus are considered stable
    /// (if the ProtoBuf definition does not change) and safe for programmatic use.
    pub fn as_str_name(&self) -> &'static str {
        match self {
            Self::Unknown => "BATTERY_STATE_UNKNOWN",
            Self::BatteryNotCharging => "BATTERY_NOT_CHARGING",
            Self::BatteryCharging => "BATTERY_CHARGING",
        }
    }
    /// Creates an enum from field names used in the ProtoBuf definition.
    pub fn from_str_name(value: &str) -> ::core::option::Option<Self> {
        match value {
            "BATTERY_STATE_UNKNOWN" => Some(Self::Unknown),
            "BATTERY_NOT_CHARGING" => Some(Self::BatteryNotCharging),
            "BATTERY_CHARGING" => Some(Self::BatteryCharging),
            _ => None,
        }
    }
}
#[derive(Clone, Copy, Debug, PartialEq, Eq, Hash, PartialOrd, Ord, ::prost::Enumeration)]
#[repr(i32)]
pub enum AllegroSettingType {
    Unknown = 0,
    AllegroAutoOtaEnable = 1,
    AllegroOhdEnable = 2,
    AllegroOobeIsFinished = 3,
    AllegroGestureEnable = 4,
    AllegroDiagnosticsEnable = 5,
    AllegroOobeMode = 6,
    AllegroGestureControl = 7,
    AllegroAncAccessibilityMode = 8,
    AllegroAncrStateOneBud = 9,
    AllegroAncrStateTwoBuds = 10,
    AllegroMultipointEnable = 11,
    AllegroAncrGestureLoop = 12,
    AllegroCurrentAncrState = 13,
    AllegroOttsMode = 14,
    AllegroVolumeEqEnable = 15,
    AllegroCurrentUserEq = 16,
    AllegroVolumeAsymmetry = 17,
    AllegroLastSavedUserEq = 18,
}
impl AllegroSettingType {
    /// String value of the enum field names used in the ProtoBuf definition.
    ///
    /// The values are not transformed in any way and thus are considered stable
    /// (if the ProtoBuf definition does not change) and safe for programmatic use.
    pub fn as_str_name(&self) -> &'static str {
        match self {
            Self::Unknown => "ALLEGRO_SETTING_TYPE_UNKNOWN",
            Self::AllegroAutoOtaEnable => "ALLEGRO_AUTO_OTA_ENABLE",
            Self::AllegroOhdEnable => "ALLEGRO_OHD_ENABLE",
            Self::AllegroOobeIsFinished => "ALLEGRO_OOBE_IS_FINISHED",
            Self::AllegroGestureEnable => "ALLEGRO_GESTURE_ENABLE",
            Self::AllegroDiagnosticsEnable => "ALLEGRO_DIAGNOSTICS_ENABLE",
            Self::AllegroOobeMode => "ALLEGRO_OOBE_MODE",
            Self::AllegroGestureControl => "ALLEGRO_GESTURE_CONTROL",
            Self::AllegroAncAccessibilityMode => "ALLEGRO_ANC_ACCESSIBILITY_MODE",
            Self::AllegroAncrStateOneBud => "ALLEGRO_ANCR_STATE_ONE_BUD",
            Self::AllegroAncrStateTwoBuds => "ALLEGRO_ANCR_STATE_TWO_BUDS",
            Self::AllegroMultipointEnable => "ALLEGRO_MULTIPOINT_ENABLE",
            Self::AllegroAncrGestureLoop => "ALLEGRO_ANCR_GESTURE_LOOP",
            Self::AllegroCurrentAncrState => "ALLEGRO_CURRENT_ANCR_STATE",
            Self::AllegroOttsMode => "ALLEGRO_OTTS_MODE",
            Self::AllegroVolumeEqEnable => "ALLEGRO_VOLUME_EQ_ENABLE",
            Self::AllegroCurrentUserEq => "ALLEGRO_CURRENT_USER_EQ",
            Self::AllegroVolumeAsymmetry => "ALLEGRO_VOLUME_ASYMMETRY",
            Self::AllegroLastSavedUserEq => "ALLEGRO_LAST_SAVED_USER_EQ",
        }
    }
    /// Creates an enum from field names used in the ProtoBuf definition.
    pub fn from_str_name(value: &str) -> ::core::option::Option<Self> {
        match value {
            "ALLEGRO_SETTING_TYPE_UNKNOWN" => Some(Self::Unknown),
            "ALLEGRO_AUTO_OTA_ENABLE" => Some(Self::AllegroAutoOtaEnable),
            "ALLEGRO_OHD_ENABLE" => Some(Self::AllegroOhdEnable),
            "ALLEGRO_OOBE_IS_FINISHED" => Some(Self::AllegroOobeIsFinished),
            "ALLEGRO_GESTURE_ENABLE" => Some(Self::AllegroGestureEnable),
            "ALLEGRO_DIAGNOSTICS_ENABLE" => Some(Self::AllegroDiagnosticsEnable),
            "ALLEGRO_OOBE_MODE" => Some(Self::AllegroOobeMode),
            "ALLEGRO_GESTURE_CONTROL" => Some(Self::AllegroGestureControl),
            "ALLEGRO_ANC_ACCESSIBILITY_MODE" => Some(Self::AllegroAncAccessibilityMode),
            "ALLEGRO_ANCR_STATE_ONE_BUD" => Some(Self::AllegroAncrStateOneBud),
            "ALLEGRO_ANCR_STATE_TWO_BUDS" => Some(Self::AllegroAncrStateTwoBuds),
            "ALLEGRO_MULTIPOINT_ENABLE" => Some(Self::AllegroMultipointEnable),
            "ALLEGRO_ANCR_GESTURE_LOOP" => Some(Self::AllegroAncrGestureLoop),
            "ALLEGRO_CURRENT_ANCR_STATE" => Some(Self::AllegroCurrentAncrState),
            "ALLEGRO_OTTS_MODE" => Some(Self::AllegroOttsMode),
            "ALLEGRO_VOLUME_EQ_ENABLE" => Some(Self::AllegroVolumeEqEnable),
            "ALLEGRO_CURRENT_USER_EQ" => Some(Self::AllegroCurrentUserEq),
            "ALLEGRO_VOLUME_ASYMMETRY" => Some(Self::AllegroVolumeAsymmetry),
            "ALLEGRO_LAST_SAVED_USER_EQ" => Some(Self::AllegroLastSavedUserEq),
            _ => None,
        }
    }
}
#[derive(Clone, Copy, Debug, PartialEq, Eq, Hash, PartialOrd, Ord, ::prost::Enumeration)]
#[repr(i32)]
pub enum RegularActionTarget {
    ActionTargetUnknown = 0,
    ActionTargetCheckNotifications = 1,
    ActionTargetPreviousTrackRepeat = 2,
    ActionTargetNextTrack = 3,
    ActionTargetPlayPauseTrack = 4,
    ActionTargetAncControl = 5,
    ActionTargetAssistantQuery = 6,
}
impl RegularActionTarget {
    /// String value of the enum field names used in the ProtoBuf definition.
    ///
    /// The values are not transformed in any way and thus are considered stable
    /// (if the ProtoBuf definition does not change) and safe for programmatic use.
    pub fn as_str_name(&self) -> &'static str {
        match self {
            Self::ActionTargetUnknown => "ACTION_TARGET_UNKNOWN",
            Self::ActionTargetCheckNotifications => "ACTION_TARGET_CHECK_NOTIFICATIONS",
            Self::ActionTargetPreviousTrackRepeat => {
                "ACTION_TARGET_PREVIOUS_TRACK_REPEAT"
            }
            Self::ActionTargetNextTrack => "ACTION_TARGET_NEXT_TRACK",
            Self::ActionTargetPlayPauseTrack => "ACTION_TARGET_PLAY_PAUSE_TRACK",
            Self::ActionTargetAncControl => "ACTION_TARGET_ANC_CONTROL",
            Self::ActionTargetAssistantQuery => "ACTION_TARGET_ASSISTANT_QUERY",
        }
    }
    /// Creates an enum from field names used in the ProtoBuf definition.
    pub fn from_str_name(value: &str) -> ::core::option::Option<Self> {
        match value {
            "ACTION_TARGET_UNKNOWN" => Some(Self::ActionTargetUnknown),
            "ACTION_TARGET_CHECK_NOTIFICATIONS" => {
                Some(Self::ActionTargetCheckNotifications)
            }
            "ACTION_TARGET_PREVIOUS_TRACK_REPEAT" => {
                Some(Self::ActionTargetPreviousTrackRepeat)
            }
            "ACTION_TARGET_NEXT_TRACK" => Some(Self::ActionTargetNextTrack),
            "ACTION_TARGET_PLAY_PAUSE_TRACK" => Some(Self::ActionTargetPlayPauseTrack),
            "ACTION_TARGET_ANC_CONTROL" => Some(Self::ActionTargetAncControl),
            "ACTION_TARGET_ASSISTANT_QUERY" => Some(Self::ActionTargetAssistantQuery),
            _ => None,
        }
    }
}
#[derive(Clone, Copy, Debug, PartialEq, Eq, Hash, PartialOrd, Ord, ::prost::Enumeration)]
#[repr(i32)]
pub enum AncState {
    Unknown = 0,
    Off = 1,
    Active = 2,
    Aware = 3,
}
impl AncState {
    /// String value of the enum field names used in the ProtoBuf definition.
    ///
    /// The values are not transformed in any way and thus are considered stable
    /// (if the ProtoBuf definition does not change) and safe for programmatic use.
    pub fn as_str_name(&self) -> &'static str {
        match self {
            Self::Unknown => "ANC_STATE_UNKNOWN",
            Self::Off => "ANC_STATE_OFF",
            Self::Active => "ANC_STATE_ACTIVE",
            Self::Aware => "ANC_STATE_AWARE",
        }
    }
    /// Creates an enum from field names used in the ProtoBuf definition.
    pub fn from_str_name(value: &str) -> ::core::option::Option<Self> {
        match value {
            "ANC_STATE_UNKNOWN" => Some(Self::Unknown),
            "ANC_STATE_OFF" => Some(Self::Off),
            "ANC_STATE_ACTIVE" => Some(Self::Active),
            "ANC_STATE_AWARE" => Some(Self::Aware),
            _ => None,
        }
    }
}
#[derive(Clone, Copy, Debug, PartialEq, Eq, Hash, PartialOrd, Ord, ::prost::Enumeration)]
#[repr(i32)]
pub enum OobeAction {
    Unknown = 0,
    SingleTap = 1,
    DoubleTap = 2,
    TripleTap = 3,
    Hold = 4,
    SwipeForward = 5,
    SwipeBackward = 6,
    SwipeUp = 7,
    SwipeDown = 8,
    Hotword = 9,
    LeftOnHead = 10,
    LeftOffHead = 11,
    RightOnHead = 12,
    RightOffHead = 13,
    SpeculativeTap = 14,
    HoldEnd = 15,
    HoldCancel = 16,
}
impl OobeAction {
    /// String value of the enum field names used in the ProtoBuf definition.
    ///
    /// The values are not transformed in any way and thus are considered stable
    /// (if the ProtoBuf definition does not change) and safe for programmatic use.
    pub fn as_str_name(&self) -> &'static str {
        match self {
            Self::Unknown => "OOBE_ACTION_UNKNOWN",
            Self::SingleTap => "OOBE_ACTION_SINGLE_TAP",
            Self::DoubleTap => "OOBE_ACTION_DOUBLE_TAP",
            Self::TripleTap => "OOBE_ACTION_TRIPLE_TAP",
            Self::Hold => "OOBE_ACTION_HOLD",
            Self::SwipeForward => "OOBE_ACTION_SWIPE_FORWARD",
            Self::SwipeBackward => "OOBE_ACTION_SWIPE_BACKWARD",
            Self::SwipeUp => "OOBE_ACTION_SWIPE_UP",
            Self::SwipeDown => "OOBE_ACTION_SWIPE_DOWN",
            Self::Hotword => "OOBE_ACTION_HOTWORD",
            Self::LeftOnHead => "OOBE_ACTION_LEFT_ON_HEAD",
            Self::LeftOffHead => "OOBE_ACTION_LEFT_OFF_HEAD",
            Self::RightOnHead => "OOBE_ACTION_RIGHT_ON_HEAD",
            Self::RightOffHead => "OOBE_ACTION_RIGHT_OFF_HEAD",
            Self::SpeculativeTap => "OOBE_ACTION_SPECULATIVE_TAP",
            Self::HoldEnd => "OOBE_ACTION_HOLD_END",
            Self::HoldCancel => "OOBE_ACTION_HOLD_CANCEL",
        }
    }
    /// Creates an enum from field names used in the ProtoBuf definition.
    pub fn from_str_name(value: &str) -> ::core::option::Option<Self> {
        match value {
            "OOBE_ACTION_UNKNOWN" => Some(Self::Unknown),
            "OOBE_ACTION_SINGLE_TAP" => Some(Self::SingleTap),
            "OOBE_ACTION_DOUBLE_TAP" => Some(Self::DoubleTap),
            "OOBE_ACTION_TRIPLE_TAP" => Some(Self::TripleTap),
            "OOBE_ACTION_HOLD" => Some(Self::Hold),
            "OOBE_ACTION_SWIPE_FORWARD" => Some(Self::SwipeForward),
            "OOBE_ACTION_SWIPE_BACKWARD" => Some(Self::SwipeBackward),
            "OOBE_ACTION_SWIPE_UP" => Some(Self::SwipeUp),
            "OOBE_ACTION_SWIPE_DOWN" => Some(Self::SwipeDown),
            "OOBE_ACTION_HOTWORD" => Some(Self::Hotword),
            "OOBE_ACTION_LEFT_ON_HEAD" => Some(Self::LeftOnHead),
            "OOBE_ACTION_LEFT_OFF_HEAD" => Some(Self::LeftOffHead),
            "OOBE_ACTION_RIGHT_ON_HEAD" => Some(Self::RightOnHead),
            "OOBE_ACTION_RIGHT_OFF_HEAD" => Some(Self::RightOffHead),
            "OOBE_ACTION_SPECULATIVE_TAP" => Some(Self::SpeculativeTap),
            "OOBE_ACTION_HOLD_END" => Some(Self::HoldEnd),
            "OOBE_ACTION_HOLD_CANCEL" => Some(Self::HoldCancel),
            _ => None,
        }
    }
}
