// This file is @generated by prost-build.
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct RpcPacket {
    /// The type of packet. Determines which other fields are used.
    #[prost(enumeration = "PacketType", tag = "1")]
    pub r#type: i32,
    /// Channel through which the packet is sent.
    #[prost(uint32, tag = "2")]
    pub channel_id: u32,
    /// Hash of the fully-qualified name of the service with which this packet is
    /// associated. For RPC packets, this is the service that processes the packet.
    #[prost(fixed32, tag = "3")]
    pub service_id: u32,
    /// Hash of the name of the method which should process this packet.
    #[prost(fixed32, tag = "4")]
    pub method_id: u32,
    /// The packet's payload, which is an encoded protobuf.
    #[prost(bytes = "vec", tag = "5")]
    pub payload: ::prost::alloc::vec::Vec<u8>,
    /// Status code for the RPC response or error.
    #[prost(uint32, tag = "6")]
    pub status: u32,
    /// Unique identifier for the call that initiated this RPC. Optionally set by
    /// the client in the initial request and sent in all subsequent client
    /// packets; echoed by the server.
    #[prost(uint32, tag = "7")]
    pub call_id: u32,
}
/// To simplify identifying the origin of a packet, client-to-server packets
/// use even numbers and server-to-client packets use odd numbers.
#[derive(Clone, Copy, Debug, PartialEq, Eq, Hash, PartialOrd, Ord, ::prost::Enumeration)]
#[repr(i32)]
pub enum PacketType {
    /// The client invokes an RPC. Always the first packet.
    Request = 0,
    /// A message in a client stream. Always sent after a REQUEST and before a
    /// CLIENT_STREAM_END.
    ClientStream = 2,
    /// The client received a packet for an RPC it did not request.
    ClientError = 4,
    /// Deprecated, do not use. Send a CLIENT_ERROR with status CANCELLED instead.
    /// TODO(b/234879973): Remove this packet type.
    DeprecatedCancel = 6,
    /// A client stream has completed.
    ClientStreamEnd = 8,
    /// The RPC has finished.
    Response = 1,
    /// Deprecated, do not use. Formerly was used as the last packet in a server
    /// stream.
    /// TODO(b/234879973): Remove this packet type.
    DeprecatedServerStreamEnd = 3,
    /// The server was unable to process a request.
    ServerError = 5,
    /// A message in a server stream.
    ServerStream = 7,
}
impl PacketType {
    /// String value of the enum field names used in the ProtoBuf definition.
    ///
    /// The values are not transformed in any way and thus are considered stable
    /// (if the ProtoBuf definition does not change) and safe for programmatic use.
    pub fn as_str_name(&self) -> &'static str {
        match self {
            Self::Request => "REQUEST",
            Self::ClientStream => "CLIENT_STREAM",
            Self::ClientError => "CLIENT_ERROR",
            Self::DeprecatedCancel => "DEPRECATED_CANCEL",
            Self::ClientStreamEnd => "CLIENT_STREAM_END",
            Self::Response => "RESPONSE",
            Self::DeprecatedServerStreamEnd => "DEPRECATED_SERVER_STREAM_END",
            Self::ServerError => "SERVER_ERROR",
            Self::ServerStream => "SERVER_STREAM",
        }
    }
    /// Creates an enum from field names used in the ProtoBuf definition.
    pub fn from_str_name(value: &str) -> ::core::option::Option<Self> {
        match value {
            "REQUEST" => Some(Self::Request),
            "CLIENT_STREAM" => Some(Self::ClientStream),
            "CLIENT_ERROR" => Some(Self::ClientError),
            "DEPRECATED_CANCEL" => Some(Self::DeprecatedCancel),
            "CLIENT_STREAM_END" => Some(Self::ClientStreamEnd),
            "RESPONSE" => Some(Self::Response),
            "DEPRECATED_SERVER_STREAM_END" => Some(Self::DeprecatedServerStreamEnd),
            "SERVER_ERROR" => Some(Self::ServerError),
            "SERVER_STREAM" => Some(Self::ServerStream),
            _ => None,
        }
    }
}
